//***************************************************************
//------------<02.Dec.2010 by Peter Reiser>----------------------
//***************************************************************

#ifndef _TRF796xBOOSTERPACK_H_
#define _TRF796xBOOSTERPACK_H_

//================================================================

#include <msp430.h>                     // processor specific header
#include "C:\TI Stuff\HF\TRF797x\Bluetooth Pairing\Hicks_Code_08_29_2012\spi_test\spi_test\types.h"
#include "C:\TI Stuff\HF\TRF797x\Bluetooth Pairing\Hicks_Code_08_29_2012\spi_test\spi_test\mcu.h"

//===============================================================

//=====MCU constants=============================================

//TRF796x IO port.
//port4 is connected to the
#define TRF_WRITE           P2OUT
#define TRF_READ            P2IN
#define TRF_DIR_IN          P2DIR = 0x00
#define TRF_DIR_OUT         P2DIR = 0xFF
#define TRF_FUNC            P2SEL = 0x00

// EN pin on the TRF796x
// P2.2 is switched in output direction
#define ENABLE_SET          P2DIR |= BIT2
#define TRF_ENABLE          P2OUT |= BIT2
#define TRF_DISABLE         P2OUT &= ~BIT2


//---- PIN operations -------------------------------------------

// IRQ on P2.0
// rising edge interrupt
#define IRQ_PIN_SET         P2DIR &= ~IRQ_PIN;
#define IRQ_PIN             BIT0
#define IRQ_PORT            P2IN
#define IRQ_ON              P2IE |= IRQ_PIN
#define IRQ_OFF             P2IE &= ~IRQ_PIN
#define IRQ_EDGE_SET        P2IES &= ~IRQ_PIN
#define IRQ_CLR             P2IFG = 0x00
#define IRQ_REQ_REG         P2IFG

#define BT_WAKE_SET			P2DIR |= BIT5;
#define BT_WAKE_ON			P2DIR |= BIT5
#define BT_WAKE_OFF			P2OUT &= ~BIT5



/*
#define LED_PORT_SET        P2DIR |= (BIT3+BIT4+BIT5);
#define LED_ALL_OFF         P2OUT &= ~(BIT3+BIT4+BIT5);
#define LED_ALL_ON          P2OUT |= (BIT3+BIT4+BIT5);
#define LED_POWER_ON        ;
#define LED_POWER_OFF       ;
#define LED_14443A_ON       P2OUT |= BIT4;
#define LED_14443A_OFF      P2OUT &= ~BIT4;
#define LED_14443B_ON       P2OUT |= BIT3;
#define LED_14443B_OFF      P2OUT &= ~BIT3;
#define LED_15693_ON        P2OUT |= BIT5;
#define LED_15693_OFF       P2OUT &= ~BIT5;
#define LED_OPEN1_ON        ;
#define LED_OPEN1_OFF       ;
#define LED_OPEN2_ON        ;
#define LED_OPEN2_OFF       ;
*/
// Hard code to only SPI mode
#define SPIMODE             1

// CSn
#define SLAVE_SELECT_PORT_SET   P2DIR |= BIT1;
#define SLAVE_SELECT_HIGH       P2OUT |= BIT1;
#define SLAVE_SELECT_LOW        P2OUT &= ~BIT1;

#define OOK_DIR_IN          ;

// SPI Config
#define SPI_FUNC            P1SEL
#define SPI_DIR             P1DIR
#define SPI_OUT             P1OUT
#define SPI_CLK             BIT4
#define SPI_MISO            BIT1
#define SPI_MOSI            BIT2

//-----Counter-timer constants-----------------------------------
#define COUNT_VALUE         TACCR0                    //counter register
#define START_COUNTER       TACTL |=  MC1             //start counter in up mode
#define STOP_COUNTER        TACTL &= ~(MC0 + MC1)     //stops the counter

//---------------------------------------------------------------
// Set timer capture register value based on clock source
// ACLK = VLO = 12kHz
#define COUNT_1ms           12
#define COUNT_60ms          723

//---------------------------------------------------------------

// 8MHz clock
#define DELAY_1ms           6780

//===============================================================

#endif
