//***************************************************************
//------------<27.Jan.2011 by Peter Reiser>----------------------
//***************************************************************

#ifndef MCU_H_
#define MCU_H_

//===============================================================

#include "C:\TI Stuff\HF\TRF797x\Bluetooth Pairing\Hicks_Code_08_29_2012\spi_test\spi_test\Hardware\trf796xBoosterPack.h"

//===============================================================


//
// MACRO-like functions
//
/******************************************************************************
 * @brief Writes a single register
 * @param a Register address
 * @param b Pointer to Buffer with data
 * @return  none
 *****************************************************************************/
#define RADIO_WRITESINGLE(a, b)     Radio_Transfer((a&0x1F), b, 1)
/******************************************************************************
 * @brief Reads a single register
 * @param a Register address
 * @param b Pointer to Buffer with data to send and where data will be stored
 * @return  none
 *****************************************************************************/
#define RADIO_READSINGLE(a, b)      Radio_Transfer(((a&0x1F)|BIT6), b, 1)
/******************************************************************************
 * @brief Writes continous registers
 * @param a Base Register address
 * @param b Pointer to Buffer with data
 * @param l lentgh
 * @return  none
 *****************************************************************************/
#define RADIO_WRITECONT(a, b, l)    Radio_Transfer(((a&0x1F)|BIT5), b, l)
/******************************************************************************
 * @brief Reads continous registers
 * @param a Register address
 * @param b Pointer to Buffer with data to send and where data will be stored
 * @param l lentgh
 * @return  none
 *****************************************************************************/
#define RADIO_READCONT(a, b, l)     Radio_Transfer(((a&0x1F)|(BIT5|BIT6)), b, l)
/******************************************************************************
 * @brief Sends a command to the radio
 * @param a Register address
 * @param b Pointer to Buffer with additional data
 * @return  none
 *****************************************************************************/
#define RADIO_DIRECTCOMMAND(a, b)    Radio_Transfer(((a&0x1F)|BIT7), b, 0)
/******************************************************************************
 * @brief Performs a raw transfer 
 * @param a Register address including mode and format
 * @param b Pointer to Buffer with data to send and where data will be stored
 * @param l lentgh
 * @return  none
 *****************************************************************************/
#define RADIO_WRITERAW(a, b, l)     Radio_Transfer(a, b, l)

#define TARGET_CID   {0x80, 0x12, 0x34, 0x56}
extern u08_t TargetCID[4];

extern void Radio_Transfer(u08_t mode_addr, u08_t *pbuf, u08_t length);

void McuDelayMillisecond(u32_t n_ms);
void McuOscSel(u08_t mode);
void McuCounterSet(void);

//===============================================================

#endif
